$Title Optimizacion inteligente de redes de Transporte de gas natural 
$Inlinecom{ }

$ontext 
This program has been modified in order to run the solver of the FCMP-NLP model 
(using GRG method) into a loop until a stopping criterion is reached. 
This stopping criterion is established as the total CPU sec time that the
NDPTS heuristic algorithm has previously used to solve each cyclic instance of the FCMP.
$offtext 

*Authors (Modified program): Conrado and Roger, June 2008

 SETS 
       i          Nodos en la red / 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 /
       ir(i)      Nodos oferta / 1, 2, 3 /
       id(i)      Nodos demanda / 10, 11, 12, 13, 14, 15 /
       prop       Propiedades del ducto /longitud, diametro, friccion, capacidad/ 
       alias(i,j); 

  SETS 
       a(i,j) Arcos en la red / 1.2, 1.3, 4.6, 5.6, 7.10, 7.11, 8.12, 8.13, 9.14, 9.15, 2.4, 3.5, 6.7, 6.8, 6.9/
       ac(i,j) Arcos compresores en la red / 2.4, 3.5, 6.7, 6.8, 6.9 /
       ap(i,j) Arcos ductos en la red / 1.2, 1.3, 4.6, 5.6, 7.10, 7.11, 8.12, 8.13, 9.14, 9.15 /;

       Scalar {Estos escalares son usados para calcular las ecuaciones que ligan a las variables
               originales (H,Q,S) con (x_ij, p _i, p_j)} 

              {Propiedades del gas} 

		gas_K   /133050/          {constante del ducto} 
		gas_e   /1.287/           {exponente isoentropico}
		gas_R   /85.2/            {constante del gas en (lbf-ft/lbm-'R)} 
		gas_Z   /0.95/            {factor de compresibilidad del gas} 
		gas_Sg  /0.6248/          {gravedad especifica}
		gas_T   /519.67/          {temperatura promedio en la succion (^R)}
		fac     /33.1944/         {factor de conversion de MMCSD a (lbm-min)}

       TABLE datducto(i,j,prop)  {Propiedades del ducto: longitud(mi), diametro(ft), friccion}

		longitud	diametro	friccion	capacidad
	1.2 	 50 		 3 		 0.0085 	 2000
	1.3 	 50 		 3 		 0.0085 	 2000
	4.6 	 50 		 3 		 0.0085 	 3000
	5.6 	 50 		 3 		 0.0085 	 3000
	7.10 	 50 		 3 		 0.0085 	 1200
	7.11 	 50 		 3 		 0.0085 	 1200
	8.12 	 50 		 3 		 0.0085 	 1200
	8.13 	 50 		 3 		 0.0085 	 1200
	9.14 	 50 		 3 		 0.0085 	 1200
	9.15 	 50 		 3 		 0.0085 	 1200;

      PARAMETER
             qu(i,j)    {limite superior del flujo volumetrico del compresor (i,j) unidades (ft^3/min)} 
             ql(i,j)    {limite inferior del flujo volumetrico del compresor (i,j) unidades (ft^3/min)}
             su(i,j)    {limite superior de velocidad del compresor (i,j) unidades (ft/min)}
             sl(i,j)    {limite inferior de velocidad del compresor (i,j) unidades (ft/min)}
             AH(i,j) 	{Coeficiente para la ecuacion del Dominio de operacion de la estacion compresora (i,j)}
             BH(i,j) 	{Coeficiente para la ecuacion del Dominio de operacion de la estacion compresora (i,j)}
             CH(i,j) 	{Coeficiente para la ecuacion del Dominio de operacion de la estacion compresora (i,j)}
             DH(i,j) 	{Coeficiente para la ecuacion del Dominio de operacion de la estacion compresora (i,j)}
             AE(i,j) 	{Coeficiente para la ecuacion de eta del compresor (i,j)}
             BE(i,j) 	{Coeficiente para la ecuacion de eta del compresor (i,j)}
             CE(i,j) 	{Coeficiente para la ecuacion de eta del compresor (i,j)}
             DE(i,j) 	{Coeficiente para la ecuacion de eta del compresor (i,j)}
             pu(i) 	{limite superior de presion en el nodo i (psia)}
             pl(i) 	{limite inferior de presion en el nodo i (psia)}
             rl(i,j) 	{valor minimo del cociente Q/S en la estacion (i,j)}
             ru(i,j) 	{valor maximo del cociente Q/S en la estacion (i,j)}
             diam(i,j) 	{conversion del diametro del ducto (i,j) de ft a pulgadas}
             cf(i,j) 	{conversion de la capacidad del flujo del gas en el ducto (i,j) en MMSCFD --> {lbm/min}
             C 		{constante del gas}
             c1(i,j) 	{resistencia del ducto (i,j) con unidades de {psia^2/MMSCFD^2}
             r(i,j) 	{convercion la resistencia del ducto (i,j) de {psia^2/MMSCFD^2 --> psia^2/(lbm/min^2)}
             ncomp(i,j)  {numero de compresores usados en la estacion (i,j)}
             gas_m 	{proporcion del radio especifico}
             gase 	{propiedades del gas}
             PHI_SURGE  {ecuacion para calcular el hmin}
             PHI_STONE  {ecuacion para calcular el hmax}
             hu(i,j)    {limite superior de cabeza adiabatica del compresor (i,j) unidades (lbf-ft/lbm)}
             hl(i,j)    {limite inferior de cabeza adiabatica del compresor (i,j) unidades (lbf-ft/lbm)}; 

      { Datos del Compresor TIPO-4  }

             qu(i,j)            =   22000;	{ Inicia el compresor  }
             ql(i,j)            =   7000;
             su(i,j)            =   9400;
             sl(i,j)            =   5000;
             AH(i,j)            =   0.00068237;
             BH(i,j)            =  -0.00090023;
             CH(i,j)            =   0.00056894;
             DH(i,j)            =  -0.00012472;
             AE(i,j)            =  134.80547339;
             BE(i,j)            =  -148.54680228;
             CE(i,j)            =  125.10132351;
             DE(i,j)            =  -32.09649544; { Finaliza el compresor }

             pu(i)              =   1200;
             pl(i)              =   200;
             rl(i,j)            =   ql(i,j)/sl(i,j);            
             ru(i,j)            =   qu(i,j)/su(i,j);            
             diam(i,j)          =   datducto(i,j,'diametro')*12;
             cf(i,j)$Ap(i,j)    =   datducto(i,j,'capacidad')*fac;
             C                  =   gas_K*gas_Z*gas_T*gas_Sg;
             c1(i,j)$Ap(i,j)    =   C*((datducto(i,j,'longitud')*datducto(i,j,'friccion'))/(diam(i,j)**5));
             r(i,j)             =   c1(i,j)/(fac**2);
             ncomp(i,j)$Ac(i,j) =   1;
             gas_m              =   (gas_e - 1)/gas_e;
             gase     	        =   (gas_Z*gas_R*gas_T)/gas_m;
             PHI_SURGE(i,j)$Ac(i,j)          =   AH(i,j) + BH(i,j)*rl(i,j) + CH(i,j)*(rl(i,j)**2) + DH(i,j)*(rl(i,j)**3);
             PHI_STONE(i,j)$Ac(i,j)          =   AH(i,j) + BH(i,j)*ru(i,j) + CH(i,j)*(ru(i,j)**2) + DH(i,j)*(ru(i,j)**3);
             hl(i,j)            =   (sl(i,j)**2)*PHI_STONE(i,j);
             hu(i,j)            =   (su(i,j)**2)*PHI_SURGE(i,j);

      PARAMETER
             o(ir)              {Cantidad de flujo de los nodos oferta (MMSCFD)}
			 / 1	400
			   2	400
			   3	400/ 

             d(id)              {Cantidad de flujo de los nodos demanda (MMSCFD)}
			 / 10	200
			   11	200
			   12	200
			   13	200
			   14	200
			   15	200/; 

      {Conversion de unidades: MMSCFD --> lbm/min}
            o(ir) = o(ir)*fac;
            d(id) = d(id)*fac;

      PARAMETER
            b(i)               {rhs de las ecuaciones de balance del flujo de masa (lbm/min)};
            b(i)  = 0;          {Inicializamos b(i)}
            b(ir) = o(ir);     {Conjunto de b(i) para los nodos oferta}
            b(id) = -d(id);   {Conjunto de b(i) para los nodos demanda}

            
      display rl,ru,gas_m,diam,C,gase,cf,c1,r,b,hl,hu;

      VARIABLES
             Y                   {Funcion Objetivo Min la sum de los costos del combustible en todas las estaciones}

             x(i,j)              {Flujo de masa en cada arco (i,j) en la red unidades(lbm/min)}

             p(i)                {Presion en el nodo i unidades (lbf/in^2)}

             s(i,j)              {Velocidad del flujo en la estacion (i,j) unidades (rpm)}

             q(i,j)              {Flujo volumetrico en la estacion (i,j) unidades (ft^3/min)}

             h(i,j)              {Cabeza adiabatica en la estacion (i,j) unidades (lbf*ft/lbm)}

             g(i,j)              {Costo de combustible en la estacion (i,j) unidades (lbf*ft/min)}

             eta(i,j)            {Eta eficiencia en la estacion (i,j)}

             ra(i,j)             {razon del cociente Q/S};

      Positive Variable x,p,s,q,h,g,eta,ra;

      EQUATIONS

             costtotal           {Function Objetivo}

             cost(i,j)           {Costo en la estacion (i,j)}

             balance(i)          {Balance de flujo en cada nodo i}

             flujogas(i,j)       {Ecuacion de flujo de gas en cada ducto (i,j)}

             cabeza(i,j)         {Cabeza adiabatica H en la estacion (i,j)}

             flvolum(i,j)        {Flujo volumetrico Q en cada estacion (i,j)}

             dominio(i,j)        {Dominio de la estacion compresora (i,j)}

             eficiencia(i,j)     {Eficiencia de la estacion compresora (i,j)}

             razon(i,j)          {Razon del cociente Q/S}

             presion(i,j)        {restriccion de la presion de succion y la presion de descarga};

      costtotal..              Y =e= sum((i,j)$Ac(i,j), g(i,j));

      cost(i,j)$Ac(i,j)..      g(i,j)*eta(i,j) =e= 1 * (x(i,j)*h(i,j));
      balance(i)..             sum(j$A(i,j), x(i,j)) - sum(j$A(j,i), x(j,i)) =e= b(i);

      flujogas(i,j)$Ap(i,j)..  (p(i)**2 - p(j)**2) =e= r(i,j) * ((x(i,j))**2);

      cabeza(i,j)$Ac(i,j)..     p(j)**gas_m =e= p(i)**gas_m*((1/gase)*(h(i,j))+1);

      flvolum(i,j)$Ac(i,j)..    ncomp(i,j)*144*p(i)*q(i,j) =e= (gas_Z*gas_R*gas_T)*x(i,j);

      dominio(i,j)$Ac(i,j)..    h(i,j) =e= (AH(i,j) + BH(i,j)*ra(i,j) + CH(i,j)*(ra(i,j)**2) + DH(i,j)*(ra(i,j)**3)) * (s(i,j)**2);

      eficiencia(i,j)$Ac(i,j).. eta(i,j) =e= AE(i,j) + BE(i,j)*ra(i,j) + CE(i,j)*(ra(i,j)**2) + DE(i,j)*(ra(i,j)**3);

      razon(i,j)$Ac(i,j)..          s(i,j)*ra(i,j) =e= q(i,j);

      presion(i,j)$Ac(i,j)..        p(i) =l= p(j);

      Model mincosto /all /;
{ ----------------------------------------------------------------------}
{ AFUERA DEL LOOP SE DEFINEN LAS COTAS PARA CADA VARIABLE}
{ ----------------------------------------------------------------------}

{ Los limites de presion dados en psia (lbf/in^2) }										{Punto inicial}
  p.up(i) = pu(i);
  p.lo(i) = pl(i);

{ Limites de operacion en cada compresor (ft^3/min) }
  q.up(i,j) = qu(i,j);
  q.lo(i,j) = ql(i,j);

{ Limites de operacion en cada compresor (ft^3/min) }
  h.up(i,j) = hu(i,j);
  h.lo(i,j) = hl(i,j);

{ Limites de la razon del flujo volumetrico y velocidad}
  ra.up(i,j) = ru(i,j);
  ra.lo(i,j) = rl(i,j);
  
{ Capacidad de flujo de gas en el ducto(i,j) y en la estacion (i,j) (lbm/min) }
  x.up(i,j)$Ap(i,j) = cf(i,j);
  x.up(i,j)$Ac(i,j) = (ncomp(i,j)*qu(i,j) * p.up(i)* 144)/(gas_Z * gas_R * gas_T);        
  x.lo(i,j)$Ac(i,j) = (ql(i,j) * p.lo(i)* 144)/(gas_Z * gas_R * gas_T);         
  
 x.fx('1','2')=200*fac;
 x.fx('1','3')=200*fac;
 x.fx('2','4')=600*fac;   
 x.fx('3','5')=600*fac;   
 x.fx('4','6')=600*fac;
 x.fx('5','6')=600*fac;
 x.fx('6','7')=400*fac;    
 x.fx('6','8')=400*fac;    
 x.fx('6','9')=400*fac;    
 x.fx('7','10')=200*fac;
 x.fx('7','11')=200*fac;
 x.fx('8','12')=200*fac;
 x.fx('8','13')=200*fac;
 x.fx('9','14')=200*fac;
 x.fx('9','15')=200*fac;

{ Limites de velocidad en cada compresor (rpm)}
  s.up(i,j) = su(i,j);
  s.lo(i,j) = sl(i,j);

{ Eficiencia del compresor (0-100 %)}
  eta.up(i,j) = 100;
  eta.lo(i,j) = 50;

{ Costo de combustible del compresor(i,j)}
  g.up(i,j)$Ac(i,j) = (x.up(i,j)*h.up(i,j))/eta.lo(i,j);
  g.lo(i,j)$Ac(i,j) = (x.lo(i,j)*h.lo(i,j))/eta.up(i,j);
 
scalar iter; iter = 0;
scalar band; band = 1;
scalar total_time; total_time = 0.0; 
scalar time_limit; time_limit = 317.2 { CPU secs that the NDPTS algorithm spent to solve the FCMP }
scalar globmin; globmin=inf; {999999999999;  (inf - A really large number)}

        set rtoned 0.2 {Relative accuracy of 1 dimensional search (default 0.2)}
        set rvstlm 4 { Step Lenght multiplier = Factor limite de crecimiento de lamda(default 4)}


{ ---------------------------------------------------------------------------
  Inside the loop, a starting-point at random is defined by considering the 
  bounded-level of each decision variable involved with the FCMP model.
  ---------------------------------------------------------------------------
}
 	 file OF_s/OF_net-c-15c5-C4_X_Fixed.dat/; {open the file}
{==================================== WHILE - BEGIN ================================================ }
while((total_time lt time_limit),	

   { Starting-point defined by bounded-random values for each variable included in the FCMP model }

	p.l(i) = (p.lo(i) + uniform(0,1)*(p.up(i) - p.lo(i)));
        q.l(i,j) = (q.lo(i,j) + uniform(0,1)*(q.up(i,j) - q.lo(i,j)));
        h.l(i,j) = (h.lo(i,j) + uniform(0,1)*(h.up(i,j) - h.lo(i,j)));
        ra.l(i,j) = (ra.lo(i,j) + uniform(0,1)*(ra.up(i,j) - ra.lo(i,j)));
        s.l(i,j) = (s.lo(i,j) + uniform(0,1)*(s.up(i,j) - s.lo(i,j)));
        eta.l(i,j) = (eta.lo(i,j) + uniform(0,1)*(eta.up(i,j) - eta.lo(i,j)));
        g.l(i,j) = (g.lo(i,j) + uniform(0,1)*(g.up(i,j) - g.lo(i,j)));
	{Ducto} x.l(i,j)$Ap(i,j) = (x.lo(i,j) + uniform(0,1)*(x.up(i,j) - x.lo(i,j)));
	{Compresor} x.l(i,j)$Ac(i,j) = (x.lo(i,j) + uniform(0,1)*(x.up(i,j) - x.lo(i,j)));
  
   { CONOPT, SNOPT, MINOS, MINOS5 }
        Option nlp = CONOPT2;
        mincosto.scaleopt = 1;
        eficiencia.scale(i,j)$Ac(i,j) = 1.0e+01 ;
        dominio.scale(i,j)$Ac(i,j) = 1.0e03;   {tunning del algoritmo }
        mincosto.OPTFILE = 1; {Tunning }
      
   { We call the solver }
        Solve mincosto using nlp minimizing Y;

   { Looking for feasibility }
   	if ( ((mincosto.modelstat eq 2) or (mincosto.modelstat eq 7)),  {* comment: model is feasible}
        	if ( (Y.l le globmin), globmin = Y.l;	{globinit(j) = x.l(j);} );
    	   );
  
   { Later, we update the time variable time_total as follows:}
 	 total_time = total_time + mincosto.resusd;  
         { RESUSD gives us the running time in CPU secs that the solver spent in each iteration } 

   if ( (band eq 1), 	 band = 2;    );
   put OF_s;
   put "=======================================       ITER" iter:8:0 "        =======================================================";put //;
   put " ***  Model Status (2 & 7 = FEASIBLE;  4 = INFEASIBLE): " mincosto.modelstat;
   	if ( ((mincosto.modelstat eq 2) or (mincosto.modelstat eq 7)),  put ' :)  :)  :)  * comment: model is feasible';);
   put ' ***  Objective value: ', Y.l;   put '  **** THEN --> Globmin: ', globmin; put //;
   put ' ***  Iteration time: ', mincosto.resusd;   put '  **** THEN  --> Total time: ', total_time; put //;
   iter = iter + 1;
   Y.l =0.0;
); 
{==================================== WHILE - END ================================================ }

  putclose OF_s; {close file}

*  Display x.l, x.m, p.l, s.l, q.l, h.l, g.l, eta.l, ra.l;
*  Display total_time, globmin;

  file roca/net-c-15c5-C4_X_Fixed.out/; {archivo salida 3}
  put roca
   
 @9#3, ' Optimizacion Inteligente de Redes de Transporte de Gas Natural'/;
    put @9#4, '============================================================== '/;
put@1#5, 'flujos'/;
put@1#6;LOOP((i,j)$Ac(i,j), put@2 x.lo(i,j), @12 x.l(i,j), @22 x.up(i,j)/);
put@40#5, 'presiones'/;  
put@1#6;LOOP((i), put@40 p.lo(i), @50 p.l(i), @60 p.up(i)/);  
put@80#5, 'valores de Q'/; 
put@1#6;LOOP((i,j)$Ac(i,j), put@80 q.lo(i,j), @90 q.l(i,j), @100 q.up(i,j)/); 
put@120#5, 'valores de S'/; 
put@1#6;LOOP((i,j)$Ac(i,j), put@120 s.lo(i,j), @130 s.l(i,j), @140 s.up(i,j)/); 
put@160#5, 'valores de Q/S'/;
put@1#6;LOOP((i,j)$Ac(i,j), put@160 ra.lo(i,j), @170 ra.l(i,j), @180 ra.up(i,j)/);  
put@200#5, 'valores de H'/;
put@1#6;LOOP((i,j)$Ac(i,j), put@200 h.lo(i,j), @210 h.l(i,j), @220 h.up(i,j)/); 

put@1#30, 'valores de ETA'/;  
put@1#31;LOOP((i,j)$Ac(i,j), put@2 eta.lo(i,j), @12 eta.l(i,j), @22 eta.up(i,j)/); 
put@40#30, 'orden de arcos'/;  
put@40#31;LOOP((i,j)$Ac(i,j), put@42 I.tl, put @45 J.tl/); 
  

